#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "neo.h"

void neo_command_device_info_apcups(neo_device *d, int type) {
  int ret, i, days, hours, minutes;
  long run;
  char val[1024];
  
  if (type==NEO_COMMAND_DEVICE_INFO_POWER) {

    ret=neo_snmp_request_by_variable(neo_device_get_name(d), ".1.3.6.1.4.1.318.1.1.1.1.1.1.0", val);
    if (ret) {
      printf("Error getting info.\n");
    } else {
      printf("  Type             : %s\n", val);
    }

    ret=neo_snmp_request_by_variable(neo_device_get_name(d), ".1.3.6.1.4.1.318.1.1.1.4.1.1.0", val);
    if (ret) {
      printf("Error getting info.\n");
    } else {
      i=atoi(val);
      printf("  Status           : ");
      if (i==1) {
	printf("Unknown\n");
      } else if (i==2) {
	printf("On line\n");
      } else if (i==3) {
	printf("On Battery\n");
      } else if (i==4) {
	printf("On SmartBoost\n");
      } else if (i==5) {
	printf("Timed Sleeping\n");
      } else if (i==6) {
	printf("Software Bypass\n");
      } else if (i==7) {
	printf("Off\n");
      } else if (i==8) {
	printf("Rebooting\n");
      } else if (i==9) {
	printf("Switched Bypass");
      } else if (i==10) {
	printf("Hardware Failure Bypass\n");
      } else if (i==11) {
	printf("Sleeping Until Power Return\n");
      } else if (i==12) {
	printf("On Smart Trim\n");
      } else {
	printf("Unknown value (%i)\n",i);
      }
    }

    
    ret=neo_snmp_request_by_variable(neo_device_get_name(d), ".1.3.6.1.4.1.318.1.1.1.4.2.3.0", val);
    if (ret) {
      printf("Error getting info.\n");
    } else {
      i=atoi(val);
      printf("  Load             : %i%%\n", i);
    }

    ret=neo_snmp_request_by_variable(neo_device_get_name(d), ".1.3.6.1.4.1.318.1.1.1.2.2.1.0", val);
    if (ret) {
      printf("Error getting info.\n");
    } else {
      i=atoi(val);
      printf("  Capacity         : %i%%\n", i);
    }

    ret=neo_snmp_request_by_variable(neo_device_get_name(d), ".1.3.6.1.4.1.318.1.1.1.2.2.3.0", val);
    if (ret) {
      printf("Error getting info.\n");
    } else {
      val[strlen(val)-2]='\0'; /* chop off last two digits */
      run=atol(val);
      days=run/86400;
      run-=days*86400;
      hours=run/3600;
      run-=hours*3600;
      minutes=run/60;
      run-=minutes*60;
      printf("  Run Time         : %i days %2.2i:%2.2i:%2.2li\n", days, hours, minutes, run);
    }

    ret=neo_snmp_request_by_variable(neo_device_get_name(d), ".1.3.6.1.4.1.318.1.1.1.2.1.2.0", val);
    if (ret) {
      printf("Error getting info.\n");
    } else {
      val[strlen(val)-2]='\0'; /* chop off last two digits */
      run=atol(val);
      days=run/86400;
      run-=days*86400;
      hours=run/3600;
      run-=hours*3600;
      minutes=run/60;
      run-=minutes*60;
      printf("  Time On Battery  : %i days %2.2i:%2.2i:%2.2li\n", days, hours, minutes, run);
    }

    ret=neo_snmp_request_by_variable(neo_device_get_name(d), ".1.3.6.1.4.1.318.1.1.1.2.2.4.0", val);
    if (ret) {
      printf("Error getting info.\n");
    } else {
      i=atoi(val);
      printf("  Battery Status   : ");
      if (i==1) {
	printf("All batteries OK\n");
      } else if (i==2) {
	printf("One or more bad!\n");
      } else {
	printf("Unknown value (%i)\n", i);
      }
    }

    ret=neo_snmp_request_by_variable(neo_device_get_name(d), ".1.3.6.1.4.1.318.1.1.1.3.2.5.0", val);
    if (ret) {
      printf("Error getting info.\n");
    } else {
      i=atoi(val);
      printf("  Last Fail Cause  : ");
      if (i==0) {
	printf("No Alarm\n");
      } else if (i==1) {
	printf("No Transfer\n");
      } else if (i==2) {
	printf("High Line Voltage\n");
      } else if (i==3) {
	printf("Brownout\n");
      } else if (i==4) {
	printf("Blackout\n");
      } else if (i==5) {
	printf("Small Momentary Sag\n");
      } else if (i==6) {
	printf("Deep Momentary Sag\n");
      } else if (i==7) {
	printf("Small Momentary Spike\n");
      } else if (i==8) {
	printf("Large Momentary Spike\n");
      } else if (i==9) {
	printf("Self Test\n");
      } else if (i==10) {
	printf("Rate of Voltage Change\n");
      } else {
	printf("Unknown value (%i)\n", i);
      }
    }

    printf("\n");
    
    ret=neo_snmp_request_by_variable(neo_device_get_name(d), ".1.3.6.1.4.1.318.1.1.1.3.2.1.0", val);
    if (ret) {
      printf("Error getting info.\n");
    } else {
      i=atoi(val);
      printf("  Input Line Volt  : %i V\n", i);
    }

    ret=neo_snmp_request_by_variable(neo_device_get_name(d), ".1.3.6.1.4.1.318.1.1.1.3.2.4.0", val);
    if (ret) {
      printf("Error getting info.\n");
    } else {
      i=atoi(val);
      printf("  Input Line Freq  : %i Hz\n", i);
    }

    printf("\n");
    
    ret=neo_snmp_request_by_variable(neo_device_get_name(d), ".1.3.6.1.4.1.318.1.1.1.4.2.1.0", val);
    if (ret) {
      printf("Error getting info.\n");
    } else {
      i=atoi(val);
      printf("  Output Line Volt : %i V\n", i);
    }

    ret=neo_snmp_request_by_variable(neo_device_get_name(d), ".1.3.6.1.4.1.318.1.1.1.4.2.2.0", val);
    if (ret) {
      printf("Error getting info.\n");
    } else {
      i=atoi(val);
      printf("  Output Line Freq : %i Hz\n", i);
    }

    ret=neo_snmp_request_by_variable(neo_device_get_name(d), ".1.3.6.1.4.1.318.1.1.1.4.2.4.0", val);
    if (ret) {
      printf("  Unable to get output current for this device.\n");
    } else {
      i=atoi(val);
      printf("  Output Current   : %i A\n", i);
    }


    
  } else {

  }
}
